﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.Collections.ObjectModel
Public Class TripHistMap
    Private Sub processHistory()

        Dim shpfileName As String = ""
        Dim heatStyle As HeatStyle
        Dim heatLayer As HeatLayer
        Dim heatMapOverlay As LayerOverlay
        Dim fs As FeatureSource

        Dim worldMapKitDesktopOverlay As New WorldMapKitWmsDesktopOverlay

        'Set the full extent and the background color
        winformsMap1.CurrentExtent = New RectangleShape(-122.278717, 47.925518, -122.278717, 47.925518)
        winformsMap1.BackgroundOverlay.BackgroundBrush = New GeoSolidBrush(GeoColor.FromArgb(255, 198, 255, 255))
        winformsMap1.Overlays.Add(worldMapKitDesktopOverlay)
        winformsMap1.ZoomOut(5000)
        On Error GoTo hist_err

        shpfileName = (My.Application.Info.DirectoryPath & "\trphst.shp")
        fs = New ShapeFileFeatureSource(shpfileName)


        heatLayer = New HeatLayer(fs)
        heatStyle = New HeatStyle
        heatLayer.Transparency = 150
        heatStyle.Alpha = 255


        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        'this turns the entire map red!!!
        '
        'heatStyle.ColorPalette.Clear()
        'For i = 255 To 0 Step -1
        '    For j = 0 To 255    '255 To 0 Step -1
        '        heatStyle.ColorPalette.Add(GeoColor.FromArgb(i, j, 0, 0))
        '    Next
        'Next
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        'this doesn't seem to do anything
        '
        'heatStyle.ColorPalette.Clear()
        'For i = 0 To 10    ' 255 To 0 Step -1
        '    For j = 255 To 150 Step -1
        '        heatStyle.ColorPalette.Add(GeoColor.FromArgb(i, j, 0, 0))
        '    Next
        'Next
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''



        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        'this gets the error:
        ' Index was out of range. Must be non-negative and less than the size of the collection.
        ' Parameter name: index
        '
        'heatStyle.ColorPalette.Clear()
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(255, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(254, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(253, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(252, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(251, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(250, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(249, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(248, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(247, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(246, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(245, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(244, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(243, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(242, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(241, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(240, 0, 0, 0))
        'heatStyle.ColorPalette.Add(GeoColor.FromArgb(255, 255, 0, 0))
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

        heatStyle.PointRadius = 0.5
        heatStyle.PointRadiusUnit = DistanceUnit.Mile
        heatStyle.PointIntensity = 10

        heatLayer.HeatStyle = heatStyle

        heatMapOverlay = New LayerOverlay
        heatMapOverlay.Layers.Add(heatLayer)

        winformsMap1.Overlays.Add("HeatOverlay", heatMapOverlay)
        winformsMap1.Refresh()
        Exit Sub
hist_err:
        MsgBox("Error processing history data" & vbCrLf & Err.Description)

    End Sub

    Private Sub TripHistMap_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        processHistory()
    End Sub
End Class
